<?php

namespace Controller;

use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;
use Util\InstanceProvider;

class ErrorClassification
{
    public function findErrorClassification(Request\Filter $request, Response $response)
    {
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            $errorClassificationService = InstanceProvider::getService()->getErrorClassification();
            $errorClassification = $errorClassificationService->findErrorClassification($conditions);
            $response->addDataset(new DataSet('errorClassification', $errorClassification));
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage() . ' Code:' . $e->getCode());
        }
    }
    
    public function saveErrorClassification(Request\DataSet $request, Response $response)
    {
        try {
            $errorClassificationService = InstanceProvider::getService()->getErrorClassification();
            $row = $request->getDataSet()->getRows()[0];
            $id = empty($row['ID']) ? NULL : $row['ID'];
            $description = $row['DESCRIPTION'];
            $status = $row['STATUS'];
            $dataSet = $errorClassificationService->saveErrorClassification($id, $description, $status);
            $response->addDataset(new DataSet('errorClassification', [$dataSet]));
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage() . ' Code:' . $e->getCode());
        }
    }
    
    public function deleteErrorClassification(Request\DataSet $request, Response $response)
    {
        try {
            $errorClassificationService = InstanceProvider::getService()->getErrorClassification();
            $row = $request->getDataSet()->getRows()[0];
            $errorClassificationId = $row['ID'];
            $errorClassificationService->deleteErrorClassification($errorClassificationId);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage() . ' Code:' . $e->getCode());
        }
    }
}