<?php
namespace Controller;

use Util\InstanceProvider;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Util\Utilities;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\ORM\DateTime;
use \Zeedhi\DevOps\Model\Projectmanagement\Entities;


class WorkedTime extends \Generated\Controller\WorkedTime {

    /** @var  \Service\Task $taskService */
    protected $taskService;
    /**
     * @var \Service\WorkedTime
     */
    private $workedTime;

    public function __construct(Manager $dataSourceManager, Utilities $utilities,\Service\WorkedTime $workedTime){
        $this->utilities = $utilities;
        parent::__construct($dataSourceManager);
        $this->workedTime = $workedTime;
    }


    public function save(Request $request, Response $response, $showMessage = true) {
        try{
            $dataSet = $request->getDataSet()->getRows();
            foreach ($dataSet as &$row) {
                $row['WORK_DATE'] = \Zeedhi\Framework\ORM\DateTime::createFromFormat(Utilities::FORMAT_DATE_DEFAULT,$row['WORK_DATE'] . ' 00:00:00');
                $workDate = $row['WORK_DATE'];
                $resourceId = $row['RESOURCE_T'];
                $row['ORGANIZATION'] = InstanceProvider::getEnvironment()->getCurrentOrganizationId();
                $row['ID'] = $this->workedTime->validateIsNew($resourceId,$workDate);
                $row['__is_new'] = !$row['ID'];
            }
            parent::save(new Request\DataSet(new DataSet($request->getDataSet()->getDataSourceName(), $dataSet),
                $request->getMethod(), $request->getRoutePath(), $request->getUserId()), $response,$showMessage);

        } catch (\Exception $e){
            throw $e;
        }
    }
}