/* Tabela TIPORECE: TABELA DE TIPO DE RECEBIMENTO*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela TIPORECE */
/* Objetivo: Gerar um log que vai registrar as alteraes na TIPORECE,
             utilizando a tabela de Logs de Operaes do VND*/
CREATE OR REPLACE TRIGGER LOG_VND_TIPORECE
AFTER DELETE OR INSERT OR UPDATE
ON TIPORECE FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(3000);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      IF NVL(:NEW.CDTIPORECE  ,'NULL') <> NVL(:OLD.CDTIPORECE  ,'NULL') THEN 
         V_DESC := 'CDTIPORECE ' || ' ' || NVL(:NEW.CDTIPORECE ,'' );
      END IF;
      IF NVL(:NEW.NMTIPORECE ,'NULL') <> NVL(:OLD.NMTIPORECE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NMTIPORECE ' || ' ' || NVL(:NEW.NMTIPORECE,'' );
      END IF;
      IF NVL(:NEW.VRTAXAADMI ,999999) <> NVL(:OLD.VRTAXAADMI ,999999) THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'VRTAXAADMI ' || ' ' || NVL(:NEW.VRTAXAADMI,'' );
      END IF;
      IF NVL(:NEW.NRDIASADMI ,'NULL') <> NVL(:OLD.NRDIASADMI ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NRDIASADMI ' || ' ' || NVL(:NEW.NRDIASADMI,'' );
      END IF;
      IF NVL(:NEW.VRMINCARTAO ,999999) <> NVL(:OLD.VRMINCARTAO ,999999) THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'VRMINCARTAO ' || ' ' || NVL(:NEW.VRMINCARTAO,'' );
      END IF;
      IF NVL(:NEW.CDTIPOTROCO ,'NULL') <> NVL(:OLD.CDTIPOTROCO ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPOTROCO ' || ' ' || NVL(:NEW.CDTIPOTROCO,'' );
      END IF;
      IF NVL(:NEW.IDEMIVALE ,'NULL') <> NVL(:OLD.IDEMIVALE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDEMIVALE ' || ' ' || NVL(:NEW.IDEMIVALE,'' );
      END IF;
      IF NVL(:NEW.IDVALE ,'NULL') <> NVL(:OLD.IDVALE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'VALE ' || ' ' || NVL(:NEW.IDVALE,'' );
      END IF;
      IF NVL(:NEW.NRORDTROCO ,'NULL') <> NVL(:OLD.NRORDTROCO ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NRORDTROCO ' || ' ' || NVL(:NEW.NRORDTROCO,'' );
      END IF;
      IF NVL(:NEW.IDDEBCLIE ,'NULL') <> NVL(:OLD.IDDEBCLIE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDDEBCLIE ' || ' ' || NVL(:NEW.IDDEBCLIE,'' );
      END IF;
      IF NVL(:NEW.CDFPIMPFIS ,'NULL') <> NVL(:OLD.CDFPIMPFIS ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDFPIMPFIS ' || ' ' || NVL(:NEW.CDFPIMPFIS,'' );
      END IF;
      IF NVL(:NEW.IDTIPORECE ,'NULL') <> NVL(:OLD.IDTIPORECE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDTIPORECE ' || ' ' || NVL(:NEW.IDTIPORECE,'' );
      END IF;
      IF NVL(:NEW.CDTPINDICE ,'NULL') <> NVL(:OLD.CDTPINDICE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPINDICE ' || ' ' || NVL(:NEW.CDTPINDICE,'' );
      END IF;
      IF NVL(:NEW.IDPERVALOR ,'NULL') <> NVL(:OLD.IDPERVALOR ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERVALOR ' || ' ' || NVL(:NEW.IDPERVALOR,'' );
      END IF;
      IF NVL(:NEW.CDINDICE ,'NULL') <> NVL(:OLD.CDINDICE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDINDICE ' || ' ' || NVL(:NEW.CDINDICE,'' );
      END IF;
      IF NVL(:NEW.DTULTATUTIPR ,TO_DATE('01/01/0001','DD/MM/YYYY')) <> NVL(:OLD.DTULTATUTIPR ,TO_DATE('01/01/0001','DD/MM/YYYY')) THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DTULTATUTIPR ' || ' ' || NVL(:NEW.DTULTATUTIPR,'' );
      END IF;
      IF NVL(:NEW.CDTPCTRECEB ,'NULL') <> NVL(:OLD.CDTPCTRECEB ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPCTRECEB ' || ' ' || NVL(:NEW.CDTPCTRECEB,'' );
      END IF;
      IF NVL(:NEW.CDAJTXADMREC ,'NULL') <> NVL(:OLD.CDAJTXADMREC ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDAJTXADMREC ' || ' ' || NVL(:NEW.CDAJTXADMREC,'' );
      END IF;
      IF NVL(:NEW.CDREDUCONT ,'NULL') <> NVL(:OLD.CDREDUCONT ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDREDUCONT ' || ' ' || NVL(:NEW.CDREDUCONT,'' );
      END IF;
      IF NVL(:NEW.DSIMPFISCAL ,'NULL') <> NVL(:OLD.DSIMPFISCAL ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DSIMPFISCAL ' || ' ' || NVL(:NEW.DSIMPFISCAL,'' );
      END IF;
      IF NVL(:NEW.IDMOSTRARECE ,'NULL') <> NVL(:OLD.IDMOSTRARECE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDMOSTRARECE ' || ' ' || NVL(:NEW.IDMOSTRARECE,'' );
      END IF;
      IF NVL(:NEW.CDBANCARTCR ,'NULL') <> NVL(:OLD.CDBANCARTCR ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDBANCARTCR ' || ' ' || NVL(:NEW.CDBANCARTCR,'' );
      END IF;
      IF NVL(:NEW.CDADMINCART ,'NULL') <> NVL(:OLD.CDADMINCART ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDADMINCART ' || ' ' || NVL(:NEW.CDADMINCART,'' );
      END IF;
      IF NVL(:NEW.IDDESABTEF ,'NULL') <> NVL(:OLD.IDDESABTEF ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDDESABTEF ' || ' ' || NVL(:NEW.IDDESABTEF,'' );
      END IF;
      IF NVL(:NEW.CDTPBAIXAREC ,'NULL') <> NVL(:OLD.CDTPBAIXAREC ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPBAIXAREC ' || ' ' || NVL(:NEW.CDTPBAIXAREC,'' );
      END IF;
      IF NVL(:NEW.IDSANGRIAAUTO ,'NULL') <> NVL(:OLD.IDSANGRIAAUTO ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDSANGRIAAUTO ' || ' ' || NVL(:NEW.IDSANGRIAAUTO,'' );
      END IF;
      IF NVL(:NEW.CDCLIENTE ,'NULL') <> NVL(:OLD.CDCLIENTE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDCLIENTE ' || ' ' || NVL(:NEW.CDCLIENTE,'' );
      END IF;
      IF NVL(:NEW.CDPRODTPRECETC ,'NULL') <> NVL(:OLD.CDPRODTPRECETC ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDPRODTPRECETC ' || ' ' || NVL(:NEW.CDPRODTPRECETC,'' );
      END IF;
      IF NVL(:NEW.CDDOCTPRECETC ,'NULL') <> NVL(:OLD.CDDOCTPRECETC ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDDOCTPRECETC ' || ' ' || NVL(:NEW.CDDOCTPRECETC,'' );
      END IF;
      IF NVL(:NEW.IDIMPTPRECETC ,'NULL') <> NVL(:OLD.IDIMPTPRECETC ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPTPRECETC ' || ' ' || NVL(:NEW.IDIMPTPRECETC,'' );
      END IF;
      IF NVL(:NEW.IDVALORCXATC ,'NULL') <> NVL(:OLD.IDVALORCXATC ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDVALORCXATC ' || ' ' || NVL(:NEW.IDVALORCXATC,'' );
      END IF;
      IF NVL(:NEW.IDUTCONTRREPIQ ,'NULL') <> NVL(:OLD.IDUTCONTRREPIQ ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTCONTRREPIQ ' || ' ' || NVL(:NEW.IDUTCONTRREPIQ,'' );
      END IF;
      IF NVL(:NEW.IDTPRECTROCAMER ,'NULL') <> NVL(:OLD.IDTPRECTROCAMER ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDTPRECTROCAMER ' || ' ' || NVL(:NEW.IDTPRECTROCAMER,'' );
      END IF;  
      IF NVL(:NEW.IDSOLIQTPARC ,'NULL') <> NVL(:OLD.IDSOLIQTPARC ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDSOLIQTPARC ' || ' ' || NVL(:NEW.IDSOLIQTPARC,'' );
      END IF; 
      IF NVL(:NEW.CDFORMPGTO ,'NULL') <> NVL(:OLD.CDFORMPGTO ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDFORMPGTO ' || ' ' || NVL(:NEW.CDFORMPGTO,'' );
      END IF; 
      IF NVL(:NEW.IDGERAFIN ,'NULL') <> NVL(:OLD.IDGERAFIN ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDGERAFIN ' || ' ' || NVL(:NEW.IDGERAFIN,'' );
      END IF; 
      IF NVL(:NEW.QTMAXPARC ,999999) <> NVL(:OLD.QTMAXPARC ,999999) THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'QTMAXPARC ' || ' ' || NVL(:NEW.QTMAXPARC,'' );
      END IF;   
      IF NVL(:NEW.VRMINPARC ,999999) <> NVL(:OLD.VRMINPARC ,999999) THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'VRMINPARC ' || ' ' || NVL(:NEW.VRMINPARC,'' );
      END IF;  
      IF NVL(:NEW.DSENDERECE ,'NULL') <> NVL(:OLD.DSENDERECE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DSENDERECE ' || ' ' || NVL(:NEW.DSENDERECE,'' );
      END IF; 
      IF NVL(:NEW.CDPAIS ,'NULL') <> NVL(:OLD.CDPAIS ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDPAIS ' || ' ' || NVL(:NEW.CDPAIS,'' );
      END IF;   
      IF NVL(:NEW.SGESTADO ,'NULL') <> NVL(:OLD.SGESTADO ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'SGESTADO ' || ' ' || NVL(:NEW.SGESTADO,'' );
      END IF;  
      IF NVL(:NEW.CDMUNICIPIO ,'NULL') <> NVL(:OLD.CDMUNICIPIO ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDMUNICIPIO ' || ' ' || NVL(:NEW.CDMUNICIPIO,'' );
      END IF; 
      IF NVL(:NEW.CDBAIRRO ,'NULL') <> NVL(:OLD.CDBAIRRO ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDBAIRRO ' || ' ' || NVL(:NEW.CDBAIRRO,'' );
      END IF;
      IF NVL(:NEW.NRCEPRECE ,'NULL') <> NVL(:OLD.NRCEPRECE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NRCEPRECE ' || ' ' || NVL(:NEW.NRCEPRECE,'' );
      END IF;
      IF NVL(:NEW.DSCOMPLERECE ,'NULL') <> NVL(:OLD.DSCOMPLERECE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DSCOMPLERECE ' || ' ' || NVL(:NEW.DSCOMPLERECE,'' );
      END IF;
      IF NVL(:NEW.DSLOGRECE ,'NULL') <> NVL(:OLD.DSLOGRECE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DSLOGRECE ' || ' ' || NVL(:NEW.DSLOGRECE,'' );
      END IF; 
      IF NVL(:NEW.NRENDERECE ,'NULL') <> NVL(:OLD.NRENDERECE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NRENDERECE ' || ' ' || NVL(:NEW.NRENDERECE,'' );
      END IF;
      IF NVL(:NEW.CDCREDENCCAR ,'NULL') <> NVL(:OLD.CDCREDENCCAR ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDCREDENCCAR ' || ' ' || NVL(:NEW.CDCREDENCCAR,'' );
      END IF;
      IF NVL(:NEW.IDPERMANUTSAN ,'NULL') <> NVL(:OLD.IDPERMANUTSAN ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERMANUTSAN ' || ' ' || NVL(:NEW.IDPERMANUTSAN,'' );
      END IF; 
      IF NVL(:NEW.CDOPERADORAINTE ,'NULL') <> NVL(:OLD.CDOPERADORAINTE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDOPERADORAINTE ' || ' ' || NVL(:NEW.CDOPERADORAINTE,'' );
      END IF; 
      IF NVL(:NEW.CDBANDEIRAINTE ,'NULL') <> NVL(:OLD.CDBANDEIRAINTE ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDBANDEIRAINTE ' || ' ' || NVL(:NEW.CDBANDEIRAINTE,'' );
      END IF;   
      IF NVL(:NEW.CDBANCARTSEFAZ ,'NULL') <> NVL(:OLD.CDBANCARTSEFAZ ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDBANCARTSEFAZ ' || ' ' || NVL(:NEW.CDBANCARTSEFAZ,'' );
      END IF;   
      IF NVL(:NEW.CDTPCTPAGAR ,'NULL') <> NVL(:OLD.CDTPCTPAGAR ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPCTPAGAR ' || ' ' || NVL(:NEW.CDTPCTPAGAR,'' );
      END IF;
      IF NVL(:NEW.IDENTRSAIDOPPAG ,'NULL') <> NVL(:OLD.IDENTRSAIDOPPAG ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDENTRSAIDOPPAG ' || ' ' || NVL(:NEW.IDENTRSAIDOPPAG,'' );
      END IF;
      IF NVL(:NEW.CDTIPOOPERPAG ,'NULL') <> NVL(:OLD.CDTIPOOPERPAG ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPOOPERPAG ' || ' ' || NVL(:NEW.CDTIPOOPERPAG,'' );      
      END IF;
      IF NVL(:NEW.CDSERIEENTR ,'NULL') <> NVL(:OLD.CDSERIEENTR ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDSERIEENTR ' || ' ' || NVL(:NEW.CDSERIEENTR,'' );
      END IF;   
      IF NVL(:NEW.IDAPROVREDZEEXT ,'NULL') <> NVL(:OLD.IDAPROVREDZEEXT ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDAPROVREDZEEXT ' || ' ' || NVL(:NEW.IDAPROVREDZEEXT,'' );
      END IF; 
      IF NVL(:NEW.IDCONSVRDEBCONS ,'NULL') <> NVL(:OLD.IDCONSVRDEBCONS ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONSVRDEBCONS ' || ' ' || NVL(:NEW.IDCONSVRDEBCONS,'' );
      END IF; 
      IF NVL(:NEW.IDSOLNSUCREDDEB ,'NULL') <> NVL(:OLD.IDSOLNSUCREDDEB ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDSOLNSUCREDDEB ' || ' ' || NVL(:NEW.IDSOLNSUCREDDEB,'' );
      END IF;
      IF NVL(:NEW.IDPERMANUTVEN ,'NULL') <> NVL(:OLD.IDPERMANUTVEN ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERMANUTVEN ' || ' ' || NVL(:NEW.IDPERMANUTVEN,'' );
      END IF;  
      IF NVL(:NEW.IDGERABAIXAUTO ,'NULL') <> NVL(:OLD.IDGERABAIXAUTO ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDGERABAIXAUTO ' || ' ' || NVL(:NEW.IDGERABAIXAUTO,'' );
      END IF; 
      IF NVL(:NEW.IDUTILVOUCHER ,'NULL') <> NVL(:OLD.IDUTILVOUCHER ,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTILVOUCHER ' || ' ' || NVL(:NEW.IDUTILVOUCHER,'' );
      END IF;
      V_ITPESQ := :NEW.CDTIPORECE;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      IF :NEW.CDTIPORECE  IS NOT NULL  THEN 
         V_DESC := 'CDTIPORECE ' || ' ' || NVL(:NEW.CDTIPORECE ,'' );
      END IF;
      IF :NEW.NMTIPORECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NMTIPORECE ' || ' ' || NVL(:NEW.NMTIPORECE,'' );
      END IF;
      IF :NEW.VRTAXAADMI IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'VRTAXAADMI ' || ' ' || NVL(:NEW.VRTAXAADMI,'' );
      END IF;
      IF :NEW.NRDIASADMI IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NRDIASADMI ' || ' ' || NVL(:NEW.NRDIASADMI,'' );
      END IF;
      IF :NEW.VRMINCARTAO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'VRMINCARTAO ' || ' ' || NVL(:NEW.VRMINCARTAO,'' );
      END IF;
      IF :NEW.CDTIPOTROCO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPOTROCO ' || ' ' || NVL(:NEW.CDTIPOTROCO,'' );
      END IF;
      IF :NEW.IDEMIVALE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDEMIVALE ' || ' ' || NVL(:NEW.IDEMIVALE,'' );
      END IF;
      IF :NEW.IDVALE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'VALE ' || ' ' || NVL(:NEW.IDVALE,'' );
      END IF;
      IF :NEW.NRORDTROCO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NRORDTROCO ' || ' ' || NVL(:NEW.NRORDTROCO,'' );
      END IF;
      IF :NEW.IDDEBCLIE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDDEBCLIE ' || ' ' || NVL(:NEW.IDDEBCLIE,'' );
      END IF;
      IF :NEW.CDFPIMPFIS IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDFPIMPFIS ' || ' ' || NVL(:NEW.CDFPIMPFIS,'' );
      END IF;
      IF :NEW.IDTIPORECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDTIPORECE ' || ' ' || NVL(:NEW.IDTIPORECE,'' );
      END IF;
      IF :NEW.CDTPINDICE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPINDICE ' || ' ' || NVL(:NEW.CDTPINDICE,'' );
      END IF;
      IF :NEW.IDPERVALOR IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERVALOR ' || ' ' || NVL(:NEW.IDPERVALOR,'' );
      END IF;
      IF :NEW.CDINDICE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDINDICE ' || ' ' || NVL(:NEW.CDINDICE,'' );
      END IF;
      IF :NEW.DTULTATUTIPR IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DTULTATUTIPR ' || ' ' || NVL(:NEW.DTULTATUTIPR,'' );
      END IF;
      IF :NEW.CDTPCTRECEB IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPCTRECEB ' || ' ' || NVL(:NEW.CDTPCTRECEB,'' );
      END IF;
      IF :NEW.CDAJTXADMREC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDAJTXADMREC ' || ' ' || NVL(:NEW.CDAJTXADMREC,'' );
      END IF;
      IF :NEW.CDREDUCONT IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDREDUCONT ' || ' ' || NVL(:NEW.CDREDUCONT,'' );
      END IF;
      IF :NEW.DSIMPFISCAL IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DSIMPFISCAL ' || ' ' || NVL(:NEW.DSIMPFISCAL,'' );
      END IF;
      IF :NEW.IDMOSTRARECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDMOSTRARECE ' || ' ' || NVL(:NEW.IDMOSTRARECE,'' );
      END IF;
      IF :NEW.CDBANCARTCR IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDBANCARTCR ' || ' ' || NVL(:NEW.CDBANCARTCR,'' );
      END IF;
      IF :NEW.CDADMINCART IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDADMINCART ' || ' ' || NVL(:NEW.CDADMINCART,'' );
      END IF;
      IF :NEW.IDDESABTEF IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDDESABTEF ' || ' ' || NVL(:NEW.IDDESABTEF,'' );
      END IF;
      IF :NEW.CDTPBAIXAREC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPBAIXAREC ' || ' ' || NVL(:NEW.CDTPBAIXAREC,'' );
      END IF;
      IF :NEW.IDSANGRIAAUTO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDSANGRIAAUTO ' || ' ' || NVL(:NEW.IDSANGRIAAUTO,'' );
      END IF;
      IF :NEW.CDCLIENTE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDCLIENTE ' || ' ' || NVL(:NEW.CDCLIENTE,'' );
      END IF;
      IF :NEW.CDPRODTPRECETC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDPRODTPRECETC ' || ' ' || NVL(:NEW.CDPRODTPRECETC,'' );
      END IF;
      IF :NEW.CDDOCTPRECETC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDDOCTPRECETC ' || ' ' || NVL(:NEW.CDDOCTPRECETC,'' );
      END IF;
      IF :NEW.IDIMPTPRECETC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPTPRECETC ' || ' ' || NVL(:NEW.IDIMPTPRECETC,'' );
      END IF;
      IF :NEW.IDVALORCXATC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDVALORCXATC ' || ' ' || NVL(:NEW.IDVALORCXATC,'' );
      END IF;
      IF :NEW.IDUTCONTRREPIQ IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTCONTRREPIQ ' || ' ' || NVL(:NEW.IDUTCONTRREPIQ,'' );
      END IF;
      IF :NEW.IDTPRECTROCAMER IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDTPRECTROCAMER ' || ' ' || NVL(:NEW.IDTPRECTROCAMER,'' );
      END IF;  
      IF :NEW.IDSOLIQTPARC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDSOLIQTPARC ' || ' ' || NVL(:NEW.IDSOLIQTPARC,'' );
      END IF; 
      IF :NEW.CDFORMPGTO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDFORMPGTO ' || ' ' || NVL(:NEW.CDFORMPGTO,'' );
      END IF; 
      IF :NEW.IDGERAFIN IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDGERAFIN ' || ' ' || NVL(:NEW.IDGERAFIN,'' );
      END IF; 
      IF :NEW.QTMAXPARC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'QTMAXPARC ' || ' ' || NVL(:NEW.QTMAXPARC,'' );
      END IF;   
      IF :NEW.VRMINPARC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'VRMINPARC ' || ' ' || NVL(:NEW.VRMINPARC,'' );
      END IF;  
      IF :NEW.DSENDERECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DSENDERECE ' || ' ' || NVL(:NEW.DSENDERECE,'' );
      END IF; 
      IF :NEW.CDPAIS IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDPAIS ' || ' ' || NVL(:NEW.CDPAIS,'' );
      END IF;   
      IF :NEW.SGESTADO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'SGESTADO ' || ' ' || NVL(:NEW.SGESTADO,'' );
      END IF;  
      IF :NEW.CDMUNICIPIO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDMUNICIPIO ' || ' ' || NVL(:NEW.CDMUNICIPIO,'' );
      END IF; 
      IF :NEW.CDBAIRRO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDBAIRRO ' || ' ' || NVL(:NEW.CDBAIRRO,'' );
      END IF;
      IF :NEW.NRCEPRECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NRCEPRECE ' || ' ' || NVL(:NEW.NRCEPRECE,'' );
      END IF;
      IF :NEW.DSCOMPLERECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DSCOMPLERECE ' || ' ' || NVL(:NEW.DSCOMPLERECE,'' );
      END IF;
      IF :NEW.DSLOGRECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DSLOGRECE ' || ' ' || NVL(:NEW.DSLOGRECE,'' );
      END IF; 
      IF :NEW.NRENDERECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NRENDERECE ' || ' ' || NVL(:NEW.NRENDERECE,'' );
      END IF;
      IF :NEW.CDCREDENCCAR IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDCREDENCCAR ' || ' ' || NVL(:NEW.CDCREDENCCAR,'' );
      END IF;
      IF :NEW.IDPERMANUTSAN IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERMANUTSAN ' || ' ' || NVL(:NEW.IDPERMANUTSAN,'' );
      END IF; 
      IF :NEW.CDOPERADORAINTE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDOPERADORAINTE ' || ' ' || NVL(:NEW.CDOPERADORAINTE,'' );
      END IF; 
      IF :NEW.CDBANDEIRAINTE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDBANDEIRAINTE ' || ' ' || NVL(:NEW.CDBANDEIRAINTE,'' );
      END IF;   
      IF :NEW.CDBANCARTSEFAZ IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDBANCARTSEFAZ ' || ' ' || NVL(:NEW.CDBANCARTSEFAZ,'' );
      END IF;   
      IF :NEW.CDTPCTPAGAR IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPCTPAGAR ' || ' ' || NVL(:NEW.CDTPCTPAGAR,'' );
      END IF;
      IF :NEW.IDENTRSAIDOPPAG IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDENTRSAIDOPPAG ' || ' ' || NVL(:NEW.IDENTRSAIDOPPAG,'' );
      END IF;
      IF :NEW.CDTIPOOPERPAG IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPOOPERPAG ' || ' ' || NVL(:NEW.CDTIPOOPERPAG,'' );
      END IF; 
      IF :NEW.CDSERIEENTR IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDSERIEENTR ' || ' ' || NVL(:NEW.CDSERIEENTR,'' );
      END IF; 
      IF :NEW.IDAPROVREDZEEXT IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDAPROVREDZEEXT ' || ' ' || NVL(:NEW.IDAPROVREDZEEXT,'' );
      END IF; 
      IF :NEW.IDCONSVRDEBCONS IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONSVRDEBCONS ' || ' ' || NVL(:NEW.IDCONSVRDEBCONS,'' );
      END IF; 
      IF :NEW.IDSOLNSUCREDDEB IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDSOLNSUCREDDEB ' || ' ' || NVL(:NEW.IDSOLNSUCREDDEB,'' );
      END IF;
      IF :NEW.IDPERMANUTVEN IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERMANUTVEN ' || ' ' || NVL(:NEW.IDPERMANUTVEN,'' );
      END IF;  
      IF :NEW.IDGERABAIXAUTO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDGERABAIXAUTO ' || ' ' || NVL(:NEW.IDGERABAIXAUTO,'' );
      END IF; 
      IF :NEW.IDUTILVOUCHER IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTILVOUCHER ' || ' ' || NVL(:NEW.IDUTILVOUCHER,'' );
      END IF;
      V_ITPESQ := :NEW.CDTIPORECE;
         V_IDTIPOOPER := '1';
      ELSE
      IF DELETING THEN
      IF :OLD.CDTIPORECE  IS NOT NULL  THEN 
         V_DESC := 'CDTIPORECE ' || ' ' || NVL(:OLD.CDTIPORECE ,'' );
      END IF;     
      IF :OLD.NMTIPORECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NMTIPORECE ' || ' ' || NVL(:OLD.NMTIPORECE,'' );
      END IF;
      IF :OLD.VRTAXAADMI IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'VRTAXAADMI ' || ' ' || NVL(:OLD.VRTAXAADMI,'' );
      END IF;
      IF :OLD.NRDIASADMI IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NRDIASADMI ' || ' ' || NVL(:OLD.NRDIASADMI,'' );
      END IF;
      IF :OLD.VRMINCARTAO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'VRMINCARTAO ' || ' ' || NVL(:OLD.VRMINCARTAO,'' );
      END IF;
      IF :OLD.CDTIPOTROCO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPOTROCO ' || ' ' || NVL(:OLD.CDTIPOTROCO,'' );
      END IF;
      IF :OLD.IDEMIVALE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDEMIVALE ' || ' ' || NVL(:OLD.IDEMIVALE,'' );
      END IF;
      IF :OLD.IDVALE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'VALE ' || ' ' || NVL(:OLD.IDVALE,'' );
      END IF;
      IF :OLD.NRORDTROCO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NRORDTROCO ' || ' ' || NVL(:OLD.NRORDTROCO,'' );
      END IF;
      IF :OLD.IDDEBCLIE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDDEBCLIE ' || ' ' || NVL(:OLD.IDDEBCLIE,'' );
      END IF;
      IF :OLD.CDFPIMPFIS IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDFPIMPFIS ' || ' ' || NVL(:OLD.CDFPIMPFIS,'' );
      END IF;
      IF :OLD.IDTIPORECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDTIPORECE ' || ' ' || NVL(:OLD.IDTIPORECE,'' );
      END IF;
      IF :OLD.CDTPINDICE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPINDICE ' || ' ' || NVL(:OLD.CDTPINDICE,'' );
      END IF;
      IF :OLD.IDPERVALOR IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERVALOR ' || ' ' || NVL(:OLD.IDPERVALOR,'' );
      END IF;
      IF :OLD.CDINDICE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDINDICE ' || ' ' || NVL(:OLD.CDINDICE,'' );
      END IF;
      IF :OLD.DTULTATUTIPR IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DTULTATUTIPR ' || ' ' || NVL(:OLD.DTULTATUTIPR,'' );
      END IF;
      IF :OLD.CDTPCTRECEB IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPCTRECEB ' || ' ' || NVL(:OLD.CDTPCTRECEB,'' );
      END IF;
      IF :OLD.CDAJTXADMREC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDAJTXADMREC ' || ' ' || NVL(:OLD.CDAJTXADMREC,'' );
      END IF;
      IF :OLD.CDREDUCONT IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDREDUCONT ' || ' ' || NVL(:OLD.CDREDUCONT,'' );
      END IF;
      IF :OLD.DSIMPFISCAL IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DSIMPFISCAL ' || ' ' || NVL(:OLD.DSIMPFISCAL,'' );
      END IF;
      IF :OLD.IDMOSTRARECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDMOSTRARECE ' || ' ' || NVL(:OLD.IDMOSTRARECE,'' );
      END IF;
      IF :OLD.CDBANCARTCR IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDBANCARTCR ' || ' ' || NVL(:OLD.CDBANCARTCR,'' );
      END IF;
      IF :OLD.CDADMINCART IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDADMINCART ' || ' ' || NVL(:OLD.CDADMINCART,'' );
      END IF;
      IF :OLD.IDDESABTEF IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDDESABTEF ' || ' ' || NVL(:OLD.IDDESABTEF,'' );
      END IF;
      IF :OLD.CDTPBAIXAREC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPBAIXAREC ' || ' ' || NVL(:OLD.CDTPBAIXAREC,'' );
      END IF;
      IF :OLD.IDSANGRIAAUTO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDSANGRIAAUTO ' || ' ' || NVL(:OLD.IDSANGRIAAUTO,'' );
      END IF;
      IF :OLD.CDCLIENTE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDCLIENTE ' || ' ' || NVL(:OLD.CDCLIENTE,'' );
      END IF;
      IF :OLD.CDPRODTPRECETC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDPRODTPRECETC ' || ' ' || NVL(:OLD.CDPRODTPRECETC,'' );
      END IF;
      IF :OLD.CDDOCTPRECETC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDDOCTPRECETC ' || ' ' || NVL(:OLD.CDDOCTPRECETC,'' );
      END IF;
      IF :OLD.IDIMPTPRECETC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDIMPTPRECETC ' || ' ' || NVL(:OLD.IDIMPTPRECETC,'' );
      END IF;
      IF :OLD.IDVALORCXATC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDVALORCXATC ' || ' ' || NVL(:OLD.IDVALORCXATC,'' );
      END IF;
      IF :OLD.IDUTCONTRREPIQ IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTCONTRREPIQ ' || ' ' || NVL(:OLD.IDUTCONTRREPIQ,'' );
      END IF;
      IF :OLD.IDTPRECTROCAMER IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDTPRECTROCAMER ' || ' ' || NVL(:OLD.IDTPRECTROCAMER,'' );
      END IF;  
      IF :OLD.IDSOLIQTPARC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDSOLIQTPARC ' || ' ' || NVL(:OLD.IDSOLIQTPARC,'' );
      END IF; 
      IF :OLD.CDFORMPGTO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDFORMPGTO ' || ' ' || NVL(:OLD.CDFORMPGTO,'' );
      END IF; 
      IF :OLD.IDGERAFIN IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDGERAFIN ' || ' ' || NVL(:OLD.IDGERAFIN,'' );
      END IF; 
      IF :OLD.QTMAXPARC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'QTMAXPARC ' || ' ' || NVL(:OLD.QTMAXPARC,'' );
      END IF;   
      IF :OLD.VRMINPARC IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'VRMINPARC ' || ' ' || NVL(:OLD.VRMINPARC,'' );
      END IF;  
      IF :OLD.DSENDERECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DSENDERECE ' || ' ' || NVL(:OLD.DSENDERECE,'' );
      END IF; 
      IF :OLD.CDPAIS IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDPAIS ' || ' ' || NVL(:OLD.CDPAIS,'' );
      END IF;   
      IF :OLD.SGESTADO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'SGESTADO ' || ' ' || NVL(:OLD.SGESTADO,'' );
      END IF;  
      IF :OLD.CDMUNICIPIO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDMUNICIPIO ' || ' ' || NVL(:OLD.CDMUNICIPIO,'' );
      END IF; 
      IF :OLD.CDBAIRRO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDBAIRRO ' || ' ' || NVL(:OLD.CDBAIRRO,'' );
      END IF;
      IF :OLD.NRCEPRECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NRCEPRECE ' || ' ' || NVL(:OLD.NRCEPRECE,'' );
      END IF;
      IF :OLD.DSCOMPLERECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DSCOMPLERECE ' || ' ' || NVL(:OLD.DSCOMPLERECE,'' );
      END IF;
      IF :OLD.DSLOGRECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'DSLOGRECE ' || ' ' || NVL(:OLD.DSLOGRECE,'' );
      END IF; 
      IF :OLD.NRENDERECE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'NRENDERECE ' || ' ' || NVL(:OLD.NRENDERECE,'' );
      END IF;
      IF :OLD.CDCREDENCCAR IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDCREDENCCAR ' || ' ' || NVL(:OLD.CDCREDENCCAR,'' );
      END IF;
      IF :OLD.IDPERMANUTSAN IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERMANUTSAN ' || ' ' || NVL(:OLD.IDPERMANUTSAN,'' );
      END IF; 
      IF :OLD.CDOPERADORAINTE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDOPERADORAINTE ' || ' ' || NVL(:OLD.CDOPERADORAINTE,'' );
      END IF; 
      IF :OLD.CDBANDEIRAINTE IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDBANDEIRAINTE ' || ' ' || NVL(:OLD.CDBANDEIRAINTE,'' );
      END IF;   
      IF :OLD.CDBANCARTSEFAZ IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDBANCARTSEFAZ ' || ' ' || NVL(:OLD.CDBANCARTSEFAZ,'' );
      END IF;   
      IF :OLD.CDTPCTPAGAR IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTPCTPAGAR ' || ' ' || NVL(:OLD.CDTPCTPAGAR,'' );
      END IF;
      IF :OLD.IDENTRSAIDOPPAG IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDENTRSAIDOPPAG ' || ' ' || NVL(:OLD.IDENTRSAIDOPPAG,'' );
      END IF;
      IF :OLD.CDTIPOOPERPAG IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDTIPOOPERPAG ' || ' ' || NVL(:OLD.CDTIPOOPERPAG,'' );
      END IF; 
      IF :OLD.CDSERIEENTR IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'CDSERIEENTR ' || ' ' || NVL(:OLD.CDSERIEENTR,'' );
      END IF; 
      IF :OLD.IDAPROVREDZEEXT IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDAPROVREDZEEXT ' || ' ' || NVL(:OLD.IDAPROVREDZEEXT,'' );
      END IF; 
      IF :OLD.IDCONSVRDEBCONS IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDCONSVRDEBCONS ' || ' ' || NVL(:OLD.IDCONSVRDEBCONS,'' );
      END IF; 
      IF :OLD.IDSOLNSUCREDDEB IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDSOLNSUCREDDEB ' || ' ' || NVL(:OLD.IDSOLNSUCREDDEB,'' );
      END IF;
      IF :OLD.IDPERMANUTVEN IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDPERMANUTVEN ' || ' ' || NVL(:OLD.IDPERMANUTVEN,'' );
      END IF;  
      IF :OLD.IDGERABAIXAUTO IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDGERABAIXAUTO ' || ' ' || NVL(:OLD.IDGERABAIXAUTO,'' );
      END IF; 
      IF :OLD.IDUTILVOUCHER IS NOT NULL THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'IDUTILVOUCHER ' || ' ' || NVL(:OLD.IDUTILVOUCHER,'' );
      END IF;
      V_ITPESQ := :OLD.CDTIPORECE;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND)
   VALUES
      ('TIPORECE',
       SYSDATE, 
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_TIPORECE','5.20.001'); END;
/
