/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

   GRAVA_LOGINTCARD

   Procedure para controlar a gravao na tabela de log de
   integrao de cardpio.

   Chave primria controlada pela novo cdigo.

   Usada internamente na STP EXPORTA_CARDAPIO.

   Criao: Dmaso (16/03/05)

*/

CREATE OR REPLACE PROCEDURE GRAVA_LOGINTCARD
( P_NRLOGINTCARD IN VARCHAR2,
  P_CDFILORIGLOG IN VARCHAR2,
  P_CDFILDESTLOG IN VARCHAR2,
  P_CDSERDESTLOG IN VARCHAR2,
  P_DTCARDESTLOG IN DATE    ,
  P_CDPRATLOG    IN VARCHAR2,
  P_CDFAPRAORIGL IN VARCHAR2,
  P_CDFAPRADESTL IN VARCHAR2,
  P_IDNUMERRO    IN VARCHAR2) IS
BEGIN
   BEGIN
      INSERT INTO LOGINTCARD
      (NRLOGINTCARD,
       CDFILDESTLOG,
       CDSERDESTLOG,
       DTCARDESTLOG,
       CDPRATLOG,
       CDFAPRAORIGL,
       CDFAPRADESTL,
       CDFILORIGLOG,
       IDNUMERRO)
      VALUES
      (P_NRLOGINTCARD,
       P_CDFILDESTLOG,
       P_CDSERDESTLOG,
       P_DTCARDESTLOG,
       P_CDPRATLOG,
       P_CDFAPRAORIGL,
       P_CDFAPRADESTL,
       P_CDFILORIGLOG,
       P_IDNUMERRO);
   EXCEPTION
      WHEN DUP_VAL_ON_INDEX THEN BEGIN
         UPDATE LOGINTCARD
         SET IDNUMERRO = IDNUMERRO
         WHERE
            NRLOGINTCARD = P_NRLOGINTCARD AND
            CDFILDESTLOG = P_CDFILDESTLOG AND
            CDSERDESTLOG = P_CDSERDESTLOG AND
            DTCARDESTLOG = P_DTCARDESTLOG AND
            CDPRATLOG    = P_CDPRATLOG;
      END;
   END;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_LOGINTCARD','4.09.067'); END;
/

