/* Sistemas Integrados TEKNISA

Nome: 9500_CVIIEO_ETL_CONTAPAGA
Descrio: view que retorna AS CONTAS PAGAS POR DATA DE BAIXA (ANO E MES)

Criao:
04/07/2012 - Ftima Fernandes
*/

CREATE OR REPLACE FORCE VIEW "DM_CONTAPAGA" ("CDEMPRESA", "CDFILIAL", "NMFILIALRECE", "NMFANTFORN", "NMRAZSOCFORN", 
"DSCONTCORR", "NMTIPOBAIXA", "NMTIPOCONTA", "CDREDUCONT", "DSCONTACORRENTE", "CDANOBI", "CDMESBI", "DSDOCSERIE", "DSDESCRICAO",
 "VRBRUTOBOLETOPAG", "VRLIQUIDOBOLETOPAG", "VRAJUSTEBOLETOPAG", "VRORIGPAG", "VRAJUSTECTPAG", "VALORPAGO",
  "QTCONTAS","QTDIASPAGO", "QTDIASVENCTO", "QTDIASATRASO", "QTBOLEMATRASO")
AS
(SELECT  BO.CDEMPRESA, BO.CDFILIAL, F.CDFILIAL || '_' || F.NMFILIAL AS NMFILIALRECE,
        FO.NMFANTFORN, FO.NMRAZSOCFORN, DSCONTCORR, TB.CDTPBAIXAPAG || '-' || NMTPBAIXAPAG AS NMTIPOBAIXA,
        CT.CDTPCTPAGAR|| '-' || DSTPCTPAGAR AS NMTIPOCONTA, BA.CDREDUCONT,
        NMBANCO||'-'||CDAGENCIA||'-'||CDCONTCORR AS DSCONTACORRENTE,
        TO_CHAR(BA.DTBAIXAPAG, 'YYYY') AS CDANOBI,
        TO_CHAR(BA.DTBAIXAPAG, 'MM') AS CDMESBI,
        (NF.NRNOTAFISC||'/'||NF.CDSERIEENTR||' - Baixa:'||BA.DTBAIXAPAG) DOC_SERIE,
        (CT.DSCONTAPAG) DESCRICAO,
        (ROUND(BO.VRBOLPAG, 2)) AS VRBRUTOBOLETOPAG,
        (ROUND(BO.VRFINALBPAG, 2)) AS VRLIQUIDOBOLETOPAG,
        (ROUND(BO.VRFINALBPAG, 2) - ROUND(BO.VRBOLPAG, 2)) AS VRAJUSTEBOLETOPAG,
        SUM (ROUND(CT.VRORIGPAG, 2)) AS VRORIGPAG,
        SUM(ROUND(CT.VRATUAPAG,2) - ROUND(CT.VRORIGPAG,2)) AS VRAJUSTECTPAG,
        SUM (ROUND(CT.VRATUAPAG, 2) + ((BO.VRFINALBPAG - BO.VRBOLPAG) * (CT.VRATUAPAG/BO.VRBOLPAG))) AS VALORPAGO,
        COUNT(*) AS QTCONTAS,
        (ROUND(TRUNC(BA.DTBAIXAPAG) - TRUNC(NF.DTENTRSAID) )) AS QTDIASPAGO,
        (ROUND(TRUNC(BO.DTVENBOLPAG) - TRUNC(NF.DTENTRSAID))) AS QTDIASVENCTO,
        (CASE WHEN TRUNC(BA.DTBAIXAPAG) > TRUNC(DTVENBOLPAG) THEN ROUND(TRUNC(BA.DTBAIXAPAG) - TRUNC(DTVENBOLPAG))  ELSE 0  END) QTDIASATRASO,
        (CASE WHEN TRUNC(BA.DTBAIXAPAG) > TRUNC(DTVENBOLPAG) THEN 1 ELSE 0 END) QTBOLEMATRASO
FROM CONTAPAGAR CT, BOLETPAGAR BO, BAIXAPAGA BA, FORNECEDOR FO, TIPOCTPAGAR TP, CONTCORR CC, BANCO B,
     NOTAFISCAL NF, FILIAL F, TIPOBAIXAPAG TB
WHERE BO.CDFILIAL = CT.CDFILIBPAG
     AND BO.NRLANBOLPAG = CT.NRLANBOLPAG
     AND BO.VRFINALBPAG <> 0
     AND BA.CDFILIAL = BO.CDFILIBAIPAG
     AND BA.NRBAIXAPAG = BO.NRBAIXAPAG
     AND FO.CDFORNECED = BO.CDFORNECED
     AND TP.CDTPCTPAGAR = CT.CDTPCTPAGAR
     AND CC.CDREDUCONT = BA.CDREDUCONT
     AND CC.CDBANCO = B.CDBANCO
     AND CT.NRLANCTONF = NF.NRLANCTONF
     AND F.CDFILIAL    = NF.CDFILIRECE
     AND BA.CDTPBAIXAPAG = TB.CDTPBAIXAPAG
     AND CT.CDFILIAL   = NF.CDFILIAL
     GROUP BY BO.CDEMPRESA, BO.CDFILIAL, F.CDFILIAL, F.NMFILIAL, FO.NMFANTFORN, FO.NMRAZSOCFORN, DSCONTCORR, 
     TB.CDTPBAIXAPAG, NMTPBAIXAPAG, CT.CDTPCTPAGAR, DSTPCTPAGAR, BA.CDREDUCONT, CT.DSCONTAPAG,
	 NMBANCO, CDAGENCIA, CDCONTCORR, BO.VRBOLPAG,BO.VRFINALBPAG,BA.DTBAIXAPAG,NF.DTENTRSAID,DTVENBOLPAG,NF.CDSERIEENTR,NF.NRNOTAFISC
    )
/
BEGIN
--Fatos--
	CRIA_FATOS('DM_CONTAPAGA', 'VRBRUTOBOLETOPAG'  	,'Vr. Bruto do Boleto'			,'Valor Bruto do Boleto'	      	,'Contas Pagas - Data de Baixa');
	CRIA_FATOS('DM_CONTAPAGA', 'VRLIQUIDOBOLETOPAG'	,'Vr. Lq. do Boleto'			,'Valor Lquido do Boleto'	      	,'Contas Pagas - Data de Baixa');
	CRIA_FATOS('DM_CONTAPAGA', 'VRAJUSTEBOLETOPAG'	,'Vr. de Ajuste do Boleto'		,'Valor de Ajuste Boleto'	      	,'Contas Pagas - Data de Baixa');
	CRIA_FATOS('DM_CONTAPAGA', 'VRORIGPAG'			,'Vr. Original da Cont. a Pag.'	,'Valor Original da Conta a Pagar' 	,'Contas Pagas - Data de Baixa');
	CRIA_FATOS('DM_CONTAPAGA', 'VRAJUSTECTPAG'		,'Vr. de Ajuste Cont. a Pag.'	,'Valor de Ajuste de Contas a Pagar','Contas Pagas - Data de Baixa');
	CRIA_FATOS('DM_CONTAPAGA', 'VALORPAGO'			,'Vr.  Pago'					,'Valor Pago'		      			,'Contas Pagas - Data de Baixa');
	CRIA_FATOS('DM_CONTAPAGA', 'QTCONTAS'   		,'Quantidade de Contas'			,'Quantidade de Contas'		      	,'Contas Pagas - Data de Baixa');
	CRIA_FATOS('DM_CONTAPAGA', 'QTDIASPAGO'			,'Dias Pagos'					,'Quantidade de Dias para o venc.'  ,'Contas Pagas - Data de Baixa');
	CRIA_FATOS('DM_CONTAPAGA', 'QTDIASVENCTO'		,'Dias para o Venc.'			,'Quantidade de Dias para o venc.'  ,'Contas Pagas - Data de Baixa');
	CRIA_FATOS('DM_CONTAPAGA', 'QTDIASATRASO'		,'Dias em Atraso'				,'Quantidade de Dias em  Atraso'    ,'Contas Pagas - Data de Baixa');
	CRIA_FATOS('DM_CONTAPAGA', 'QTBOLEMATRASO'    	,'Quant. de Boleto em atraso'	,'Quantidade de Boleto em  Atraso'  ,'Contas Pagas - Data de Baixa');
		
--Dimenso--	
	CRIA_DIME('DM_CONTAPAGA'	,'CDEMPRESA'	,'Empresa'			,'EMPRESA','CDEMPRESA'	  ,'NMEMPRESA'	  ,NULL);
	CRIA_DIME('DM_CONTAPAGA'	,'CDFILIAL'	,'Filial'			,'FILIAL' ,'CDFILIAL' 	  ,'NMFILIAL' 	  ,NULL);
    CRIA_DIME('DM_CONTAPAGA'	,'NMFILIALRECE'	,'Filial de Recebimento'	,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGA'	,'NMFANTFORN'	,'Nome Fantasia'		,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGA'	,'NMRAZSOCFORN'	,'Razo Social'			,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGA'	,'NMTIPOBAIXA'	,'Tipo de Baixa'		,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGA'	,'NMTIPOCONTA'	,'Tipo de Conta'		,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_CONTAPAGA'	,'CDREDUCONT'	,'Cdigo do Banco'		,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_CONTAPAGA'	,'DSCONTACORRENTE'	,'Conta Corrente'		,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_CONTAPAGA'	,'CDANOBI'	,'Ano'				,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGA'	,'CDMESBI'	,'Ms'				,NULL	  ,NULL		  ,NULL		  ,NULL);
CRIA_DIME('DM_CONTAPAGA'	,'DSDOCSERIE'	,'Doc/Serie'				,NULL	  ,NULL		  ,NULL		  ,NULL);
CRIA_DIME('DM_CONTAPAGA'	,'DSDESCRICAO'	,'Descrio'				,NULL	  ,NULL		  ,NULL		  ,NULL);
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('DM_CONTAPAGA','5.09.105'); END;
/