create or replace
PROCEDURE IMPORTA_FORNECEDOR_CHQ
IS
   /* FORNECEDOR */
   V_CDFORNECED  VARCHAR2(20);
   V_NMRAZAOSOC  VARCHAR2(40);
   V_NMFANTFORN  VARCHAR2(40);
   V_DSENDERECO  VARCHAR2(40);
   V_CDPAIS      VARCHAR2(4);
   V_SGESTADO    VARCHAR2(2);
   V_CDMUNICIPIO VARCHAR2(7);
   V_CDCEP       VARCHAR2(15);
   V_NMBAIRRO    VARCHAR2(30);
   V_EMAIL       VARCHAR2(40);
   V_IDINTERFACE INTEGER;
   V_TPINTERFACE VARCHAR2(1);
   V_CDPAISP     VARCHAR2(4);
   V_SGESTADOP   VARCHAR2(2);
   V_CDMUNICIP   VARCHAR2(7);
   V_FORNECEDOR  VARCHAR2(21);
   V_VALIDA      VARCHAR2(15);
   V_TPIJURFORN  VARCHAR2(1);
   V_NRINSJURFOR VARCHAR2(21);
   /* LOG */
   V_IDSEQLOG    INTEGER;
   V_MENSERRO    VARCHAR2(250);

   CURSOR C_FORNECEDOR IS
      SELECT U.CDFORNECEDOR, U.NMRAZAOSOC, U.NMFANTFORNE, U.DSENDERECOP, P.CDPAIS,
             E.SGESTADO, M.CDMUNICIPIO, U.CDCEPP, U.NMBAIRROP, U.EMAIL,
             U.IDINTERFACE, U.TPINTERFACE, U.CDPAISP, U.SGESTADOP, U.CDMUNICIPIOP
        FROM USR_CHQ_FORNECEDOR U LEFT OUTER JOIN PAIS P
                                               ON U.CDPAISP   = P.CDPAIS
                                  LEFT OUTER JOIN ESTADO E
                                               ON U.CDPAISP   = E.CDPAIS
                                              AND U.SGESTADOP = E.SGESTADO
                                  LEFT OUTER JOIN MUNICIPIO M
                                               ON U.CDPAISP   = M.CDPAIS
                                              AND U.SGESTADOP = M.SGESTADO
                                              AND U.CDMUNICIPIOP = M.CDMUNICIBGE
       WHERE U.STATUS = 1;
   
   FUNCTION DIGITO_VERIF(P_VALOR IN INTEGER) RETURN INTEGER
   IS
      VALOR INTEGER;
   BEGIN
      VALOR := MOD(P_VALOR,11);
      IF VALOR < 2 THEN
         VALOR := 0;
      ELSE
         VALOR := 11-VALOR;
      END IF;
      
      RETURN VALOR;
   END;
   
   PROCEDURE VALIDA_INSC(P_INSCRICAO IN VARCHAR2, P_TIPOINSC IN VARCHAR2, P_DIGVERIF OUT VARCHAR2)
   IS
      DIGVERIF VARCHAR2(15);
      CALC INTEGER;
      DIGITO INTEGER;
      TYPE VET_CNPJ IS VARRAY(13) OF INTEGER;
      VETOR VET_CNPJ;
      BOPRIMEIRO BOOLEAN;
   BEGIN   
      DIGITO := 0;
      
      IF P_TIPOINSC = 'F' THEN
         SELECT REVERSE(P_INSCRICAO)
           INTO DIGVERIF
           FROM DUAL;
         
         FOR I IN 1..LENGTH(DIGVERIF)
         LOOP
            CALC := TO_NUMBER(SUBSTR(DIGVERIF,I,1))*(I+1);
            DIGITO := DIGITO + CALC;
         END LOOP;
         
         DIGITO := DIGITO_VERIF(DIGITO);
         
         DIGVERIF := DIGITO||DIGVERIF;
         SELECT REVERSE(DIGVERIF)
           INTO DIGVERIF
           FROM DUAL;
         
         IF LENGTH(DIGVERIF) < 11 THEN
            VALIDA_INSC(DIGVERIF, P_TIPOINSC, P_DIGVERIF);
         ELSE
            P_DIGVERIF := DIGVERIF;
         END IF;
      ELSE
         DIGVERIF := P_INSCRICAO;
         IF LENGTH(DIGVERIF) = 12 THEN
            VETOR := VET_CNPJ(5,4,3,2,9,8,7,6,5,4,3,2);
            BOPRIMEIRO := TRUE;
         ELSE
            VETOR := VET_CNPJ(6,5,4,3,2,9,8,7,6,5,4,3,2);
            BOPRIMEIRO := FALSE;
         END IF;
         
         FOR I IN 1..LENGTH(DIGVERIF)
         LOOP
            CALC := TO_NUMBER(SUBSTR(DIGVERIF,I,1))*VETOR(I);
            DIGITO := DIGITO + CALC;
         END LOOP;
         
         DIGITO := DIGITO_VERIF(DIGITO);
         DIGVERIF := DIGVERIF||DIGITO;
         
         IF BOPRIMEIRO THEN
            VALIDA_INSC(DIGVERIF, P_TIPOINSC, P_DIGVERIF);
         ELSE
            P_DIGVERIF := DIGVERIF;
         END IF;         
      END IF;
   END;    
       
BEGIN
   OPEN C_FORNECEDOR;
   LOOP
      FETCH C_FORNECEDOR INTO V_CDFORNECED, V_NMRAZAOSOC, V_NMFANTFORN, V_DSENDERECO, V_CDPAIS,
                              V_SGESTADO, V_CDMUNICIPIO, V_CDCEP, V_NMBAIRRO, V_EMAIL,
                              V_IDINTERFACE, V_TPINTERFACE, V_CDPAISP, V_SGESTADOP, V_CDMUNICIP;
      EXIT WHEN C_FORNECEDOR%NOTFOUND;
      
      V_VALIDA := '';
      V_CDFORNECED := REGEXP_REPLACE(V_CDFORNECED, '\D');
      SELECT USR_CHQ_IDSEQLOG.NEXTVAL
        INTO V_IDSEQLOG
        FROM DUAL;
      BEGIN
         SELECT MAX(CDFORNECED) AS FORNECEDOR
           INTO V_FORNECEDOR
           FROM FORNECEDOR
          WHERE REGEXP_LIKE(NRINSJURFORN, '(^0*0|^)'||V_CDFORNECED||'$');
      EXCEPTION
         WHEN OTHERS THEN
            V_FORNECEDOR := NULL;
      END;
      
      IF (V_TPINTERFACE <> 'E') THEN
         IF (V_CDPAIS IS NOT NULL) THEN
            IF (V_SGESTADO IS NOT NULL) THEN
               IF (V_CDMUNICIPIO IS NOT NULL) THEN
                  IF (V_TPINTERFACE = 'I') THEN
                     IF (V_FORNECEDOR IS NULL) THEN
                        CASE
                           WHEN LENGTH(V_CDFORNECED)<= 5  THEN V_TPIJURFORN := 'O';
                           WHEN LENGTH(V_CDFORNECED) = 11 THEN V_TPIJURFORN := 'F';
                           WHEN LENGTH(V_CDFORNECED) = 14 THEN V_TPIJURFORN := 'J';
                        END CASE;
                        
                        BEGIN
                           IF (V_TPIJURFORN = 'F') OR (V_TPIJURFORN = 'J') THEN
                              VALIDA_INSC(SUBSTR(V_CDFORNECED,1,LENGTH(V_CDFORNECED)-2), V_TPIJURFORN, V_VALIDA);
                           END IF;   
                           
                           IF (V_VALIDA = V_CDFORNECED) THEN
                              V_FORNECEDOR := V_TPIJURFORN||V_CDFORNECED;
                              V_NRINSJURFOR := V_CDFORNECED;
                           ELSE
                              /* CASO O DIGITO DO CPF/CNPJ SEJA INVALIDO OU A INSCRICAO POSSUA QUANTIDADE DE CARACTERES DIFERENTES
                                 DOS CITADOS, O FORNECEDOR SERA INCLUIDO COM A INSCRICAO 'I' (SE MAIOR QUE 5 CARACTERS) OU 'O', 
                                 COMPLETANDO ASSIM COM 0 (ZEROS) A ESQUERDA SE NECESSARIO */
                              IF (LENGTH(V_CDFORNECED)>5) THEN
                                 V_TPIJURFORN := 'I';
                                 V_NRINSJURFOR  := LPAD(V_CDFORNECED,20,'0');
                                 V_FORNECEDOR := V_TPIJURFORN||V_NRINSJURFOR;
                              ELSE
                                 V_NRINSJURFOR := LPAD(V_CDFORNECED,5,'0');
                                 V_FORNECEDOR := V_TPIJURFORN||V_NRINSJURFOR;
                              END IF;
                           END IF;
                           
                           INSERT INTO FORNECEDOR(CDFORNECED, IDTPIJURFORN, NRINSJURFORN, NMRAZSOCFORN, NMFANTFORN)
                           VALUES(V_FORNECEDOR, V_TPIJURFORN, V_NRINSJURFOR, V_NMRAZAOSOC, V_NMFANTFORN);
                           
                           INSERT INTO ENDEFORN(CDFORNECED, DSENDEFORN, CDPAIS, SGESTADO, CDMUNICIPIO, IDTPENDEFORN)
                           VALUES(V_FORNECEDOR, V_DSENDERECO, V_CDPAIS, V_SGESTADO, V_CDMUNICIPIO, 'P');
                           
                           UPDATE USR_CHQ_FORNECEDOR
                              SET STATUS = 0
                            WHERE IDINTERFACE = V_IDINTERFACE;
                           
                           INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                           VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 0, 'Fornecedor inserido com sucesso');
                        EXCEPTION
                           WHEN OTHERS THEN
                              V_MENSERRO := SQLERRM(SQLCODE);
                              UPDATE USR_CHQ_FORNECEDOR
                                 SET STATUS = 2
                               WHERE IDINTERFACE = V_IDINTERFACE;
                              
                              INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                              VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 1, 'Erro ao incluir o fornecedor '||V_CDFORNECED||': '||V_MENSERRO);
                        END;
                     ELSE
                        UPDATE USR_CHQ_FORNECEDOR
                           SET STATUS = 2
                         WHERE IDINTERFACE = V_IDINTERFACE;
                        
                        INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                        VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 1, 'Fornecedor j'||CHR(225)||' cadastrado');
                     END IF;
                  ELSE
                     IF (V_FORNECEDOR IS NOT NULL) THEN
                        BEGIN
                           UPDATE FORNECEDOR
                              SET NMRAZSOCFORN = V_NMRAZAOSOC,
                                  NMFANTFORN   = V_NMFANTFORN
                            WHERE CDFORNECED = V_FORNECEDOR;
                           
                            UPDATE ENDEFORN
                               SET DSENDEFORN  = V_DSENDERECO,
                                   CDPAIS      = V_CDPAIS,
                                   SGESTADO    = V_SGESTADO,
                                   CDMUNICIPIO = V_CDMUNICIPIO,
                                   NRCEPFORN   = V_CDCEP,
                                   NMBAIRFORN  = V_NMBAIRRO,
                                   DSEMAILFORN = V_EMAIL
                            WHERE CDFORNECED = V_FORNECEDOR;
                            
                           UPDATE USR_CHQ_FORNECEDOR
                              SET STATUS = 0
                            WHERE IDINTERFACE = V_IDINTERFACE;
                           
                           INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                           VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 0, 'Fornecedor atualizado com sucesso');
                        EXCEPTION
                           WHEN OTHERS THEN
                              V_MENSERRO := SQLERRM(SQLCODE);
                              UPDATE USR_CHQ_FORNECEDOR
                                 SET STATUS = 2
                               WHERE IDINTERFACE = V_IDINTERFACE;
                              
                              INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                              VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 1, 'Erro ao atualizar o fornecedor '||V_CDFORNECED||': '||V_MENSERRO);
                        END;
                     ELSE
                        UPDATE USR_CHQ_FORNECEDOR
                           SET STATUS = 2
                         WHERE IDINTERFACE = V_IDINTERFACE;
                        
                        INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                        VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' fornecedor com o c'||CHR(243)||'digo '||V_FORNECEDOR||' cadastrado no sistema');
                     END IF;
                  END IF;
               ELSE
                  UPDATE USR_CHQ_FORNECEDOR
                     SET STATUS = 2
                   WHERE IDINTERFACE = V_IDINTERFACE;
                  
                  INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' munic'||CHR(237)||'pio com o c'||CHR(243)||'digo IBGE '||V_CDMUNICIP||' cadastrado no sistema');
               END IF;
            ELSE
               UPDATE USR_CHQ_FORNECEDOR
                  SET STATUS = 2
                WHERE IDINTERFACE = V_IDINTERFACE;
               
               INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' estado com a sigla '||V_SGESTADOP||' cadastrado no sistema');
            END IF;
         ELSE
            UPDATE USR_CHQ_FORNECEDOR
               SET STATUS = 2
             WHERE IDINTERFACE = V_IDINTERFACE;
            
            INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
            VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' pa'||CHR(237)||'s com o c'||CHR(243)||'digo '||V_CDPAISP||' cadastrado no sistema');
         END IF;
      ELSE
         BEGIN
            DELETE FROM FORNECEDOR CASCADE
             WHERE CDFORNECED = V_FORNECEDOR;
            
            IF SQL%ROWCOUNT > 0 THEN
               UPDATE USR_CHQ_FORNECEDOR
                  SET STATUS = 0
                WHERE IDINTERFACE = V_IDINTERFACE;
               
               INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 0, 'Fornecedor apagado com sucesso');
            ELSE
               UPDATE USR_CHQ_FORNECEDOR
                  SET STATUS = 2
                WHERE IDINTERFACE = V_IDINTERFACE;
               
               INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 1, 'N'||CHR(227)||'o h'||CHR(225)||' fornecedor cadastrado com o c'||CHR(243)||'digo '||V_CDFORNECED);
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
               V_MENSERRO := SQLERRM(SQLCODE);
               UPDATE USR_CHQ_FORNECEDOR
                  SET STATUS = 2
                WHERE IDINTERFACE = V_IDINTERFACE;
               
               INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 1, 'Erro ao excluir o fornecedor '||V_CDFORNECED||': '||V_MENSERRO);
         END;
      END IF;
   END LOOP;
   
   CLOSE C_FORNECEDOR;
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      V_MENSERRO := SQLERRM(SQLCODE);
      UPDATE USR_CHQ_FORNECEDOR
         SET STATUS = 2
       WHERE IDINTERFACE = V_IDINTERFACE;
      
      INSERT INTO USR_CHQ_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
      VALUES(V_IDINTERFACE, V_IDSEQLOG, 1, SYSDATE, 1, 'Erro na importao do fornecedor '||V_CDFORNECED||': '||V_MENSERRO);
      
      CLOSE C_FORNECEDOR;
   
      COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_FORNECEDOR_CHQ','6.05.XXX'); END;
/